using System;
using System.Xml.Serialization;

// Pridejte dalsi pretizeny konstruktor, ktery rovnou naplni _Jmeno a _Prijmeni
// Pridejte funkci, ktera vrati inicialy cloveka napr. "Jiri Pokorny" vrati "JP"
// Pridejte dalsi vlastnosti cloveka napr. telefon, email apod
// Pridajte metody, ktore budu zapisovat/citat objekt clovek do textoveho/xml suboru. Vytvorte metody v triede clovek, 
// alebo vytvorte staticke metody vo TextWorker a XMLWorker
namespace IW5_cv02
{
  [Serializable]
  public class Person
  {

    #region Private Fields
    private string name = "";
    private string surname = "";
    private string contact = "";

    private IWorker persistance;

    #endregion

    #region Public Properties
    public string Name
    {
      get { return name; }
      set { name = value; }
    }

    public string SurName
    {
      get { return surname; }
      set { surname = value; }
    }

    public string Contact
    {
      get { return contact; }
      set { contact = value; }
    }

    [XmlIgnore]
    public IWorker Persistance
    {
      get { return persistance; }
      set { persistance = value; }
    }
    #endregion

    #region Public Methods

    public string CeleJmeno()
    {
      return name + " " + surname;
    }

    public void Save()
    {
      if (persistance != null)
        persistance.Save(this);
    }

    public void Load()
    {
      if (persistance != null)
      {
        Person p = persistance.Load();
        this.Name = p.Name;
        this.SurName = p.SurName;
        this.Contact = p.Contact;
      }
    }

    #endregion

    #region Constructors

    public Person()
    {
      this.persistance = new TextWorker();
    }

    #endregion

  }
}
